/*
    The file is copyright Andrew Wilkinson <aw@cs.york.ac.uk> 2004.

    This file is part of PyLinda (http://www-users.cs.york.ac.uk/~aw/pylinda)

    PyLinda is free software;
 you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation;
 either version 2 of the License, or
    (at your option) any later version.

    PyLinda is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY;
 without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar;
 if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "pylinda.h"

#include <stdio.h>

#define MaxIters 256*256

int main(int argc, char* argv[]) {
   linda.TupleSpace* out;

   linda.TupleSpace* pix;


   PyObject* r;



Py_Initialize();
PySys_SetArgv(init_linda(argc, argv), argc);

PyLinda_linda_module = PyImport_Import(Py_BuildValue("s", "linda"));
CheckNULL(PyLinda_linda_module);

PyLinda_connect = PyObject_GetAttrString(linda_module, "connect");
CheckNULL(PyLinda_connect);

PyLinda_tuplespace = PyObject_GetAttrString(linda_module, "tuplespace");
CheckNULL(PyLinda_tuplespace);

PyLinda_universe = PyObject_GetAttrString(linda_module, "universe");
CheckNULL(PyLinda_universe);
    ;


   double col_mul;


   col_mul = (pow(2, 24)-1)/((double)MaxIters);


   linda.connect();


   out = linda.universe._rd(("out", linda.TupleSpace));

   pix = linda.universe._rd(("pix", linda.TupleSpace));


   printf("%i %i\n", (int)out, (int)pix);


   while(1) {
       PyObject* t;

       int x;
 int y;

       double cr;
 double ci;

       double zr;
 double zi;

       double rsquared;
 double isquared;

       int count;


       x, y, cr, ci = pix._inp((int, int, float, float))
       else {
           break
       }

       printf("got %i %i\n", x, y);


       zr = 0.0;
 zi = 0.0;

       rsquared = zr * zr;

       isquared = zi * zi;

       count = -1;

       while(rsquared + isquared <= 4.0 && count < MaxIters) {
           count += 1;


           zi = zr * zi * 2 + ci;

           zr = rsquared - isquared + cr;


           rsquared = zr * zr;

           isquared = zi * zi;

       }

       count = (int)(count * col_mul);


       pix._out((x:int, y:int, (count)%256:int, (count>>8)%256:int, (count>>16)%256:int));

   }

   linda.disconnect();


   return 0;

}
